import BinderContract from '../Contracts/Container/Binder';
import Container from './Container';
import { Binding, Identifier, Instantiable } from '../types/container';
declare class Binder implements BinderContract {
    protected _container: Container;
    protected _bindings: Map<any, Binding>;
    protected _reboundCallbacks: Map<any, Function[]>;
    constructor(container: Container);
    hasBinding<T>(abstract: Identifier<T>): boolean;
    getBinding<T>(abstract: Identifier<T>): Binding | undefined;
    bound<T>(abstract: Identifier<T>): boolean;
    bindIf<U, V>(abstract: Identifier<U>, concrete?: Instantiable<V> | Function, shared?: boolean): void;
    bind<U, V>(abstract: Identifier<U>, concrete?: Instantiable<V> | Function, shared?: boolean): void;
    rebound<T>(abstract: Identifier<T>): void;
    rebinding<T>(abstract: Identifier<T>, callback: Function): unknown | undefined;
    getBindings(): Map<any, Binding>;
    forgetBinding<T>(abstract: Identifier<T>): void;
    forgetBindings(): void;
    protected _getReboundCallbacks<T>(abstract: Identifier<T>): Function[];
    protected _dropStaleInstances<T>(abstract: Identifier<T>): void;
}
export default Binder;
