import BuilderContract from '../Contracts/Container/Builder';
import Container from './Container';
import ReflectionParameter from '../Reflection/ReflectionParameter';
import { Instantiable } from '../types/container';
declare class Builder implements BuilderContract {
    protected _container: Container;
    protected _buildStack: any[];
    protected _with: any | object[];
    constructor(container: Container);
    private static _formatName;
    build<T>(concrete: Instantiable<T> | Function): any;
    pushParameterOverride(parameters: any[] | object): void;
    popParameterOverride(): void;
    getLatestBuild(): any[];
    protected _resolveDependencies(dependencies: ReflectionParameter[]): any[];
    protected _hasParameterOverride(dependency: ReflectionParameter): boolean;
    protected _getParameterOverride(dependency: ReflectionParameter): any;
    protected _getLastParameterOverride(): any[] | object;
    protected _resolvePrimitive(parameter: ReflectionParameter): any | undefined;
    protected _resolveClass(parameter: ReflectionParameter): any;
    protected _notInstantiable<T>(concrete: T): void;
    protected _unresolvablePrimitive(parameter: ReflectionParameter): void;
}
export default Builder;
